# 1 "md5.c"


































# 1 "./md5.h"








































# 43 "./md5.h"

typedef unsigned long int UINT4;



typedef struct {
  UINT4 i[2];                   
  UINT4 buf[4];                                    
  unsigned char in[64];                              
  unsigned char digest[16];     
} MD5_CTX;

void MD5Init();
void MD5Update();
void MD5Final();
void Transform();

# 35 "md5.c"












static unsigned char PADDING[64] = {
  0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};




































void MD5Init (mdContext)
# 93 "md5.c"
MD5_CTX *mdContext;
{
  mdContext->i[0] = mdContext->i[1] = (UINT4)0;

  

  mdContext->buf[0] = (UINT4)0x67452301L;
  mdContext->buf[1] = (UINT4)0xefcdab89L;
  mdContext->buf[2] = (UINT4)0x98badcfeL;
  mdContext->buf[3] = (UINT4)0x10325476L;
}





void MD5Update (mdContext,inBuf,
inLen)
# 109 "md5.c"
register MD5_CTX *mdContext;
# 109 "md5.c"
unsigned char *inBuf;
unsigned int inLen;
{
  register int i, ii;
  int mdi;
  UINT4 in[16];

  
  mdi = (int)((mdContext->i[0] >> 3)& 0x3F);

  
  if ((mdContext->i[0] + ((UINT4)inLen << 3))< mdContext->i[0])
    mdContext->i[1]++;
  mdContext->i[0] += ((UINT4)inLen << 3);
  mdContext->i[1] += ((UINT4)inLen >> 29);

  while (inLen--) {
    
    mdContext->in[mdi++] = *inBuf++;

    
    if (mdi == 0x40) {
      for (i = 0,ii = 0; i < 16; i++,ii += 4)
        in[i] = (((UINT4)mdContext->in[ii+3])<< 24) |
                (((UINT4)mdContext->in[ii+2])<< 16) |
                (((UINT4)mdContext->in[ii+1])<< 8) |
                ((UINT4)mdContext->in[ii]);
      Transform (mdContext->buf,in);
      mdi = 0;
    }
  }
}




void MD5Final (mdContext)
# 145 "md5.c"
MD5_CTX *mdContext;
{
  UINT4 in[16];
  int mdi;
  unsigned int i, ii;
  unsigned int padLen;

  
  in[14] = mdContext->i[0];
  in[15] = mdContext->i[1];

  
  mdi = (int)((mdContext->i[0] >> 3)& 0x3F);

  
  padLen = (mdi < 56) ? (56 - mdi) : (120 - mdi);
  MD5Update (mdContext,PADDING,padLen);

  
  for (i = 0,ii = 0; i < 14; i++,ii += 4)
    in[i] = (((UINT4)mdContext->in[ii+3])<< 24) |
            (((UINT4)mdContext->in[ii+2])<< 16) |
            (((UINT4)mdContext->in[ii+1])<< 8) |
            ((UINT4)mdContext->in[ii]);
  Transform (mdContext->buf,in);

  
  for (i = 0,ii = 0; i < 4; i++,ii += 4) {
    mdContext->digest[ii] = (unsigned char)(mdContext->buf[i] & 0xFF);
    mdContext->digest[ii+1] =
      (unsigned char)((mdContext->buf[i] >> 8)& 0xFF);
    mdContext->digest[ii+2] =
      (unsigned char)((mdContext->buf[i] >> 16)& 0xFF);
    mdContext->digest[ii+3] =
      (unsigned char)((mdContext->buf[i] >> 24)& 0xFF);
  }
}





void Transform(buf,in)
# 187 "md5.c"
register UINT4 *buf;
# 187 "md5.c"
register UINT4 *in;
{
  register UINT4 a = buf[0], b = buf[1], c = buf[2], d = buf[3];

  




  {(a) += ((((b))& ((c)))| ((~(b))& ((d)))) + (in[ 0]) + (UINT4)(0xD76AA478L); (a) = ((((a))<< ((7)))| (((a))>> (32-((7))))); (a) += (b); }; 
  {(d) += ((((a))& ((b)))| ((~(a))& ((c)))) + (in[ 1]) + (UINT4)(0xE8C7B756L); (d) = ((((d))<< ((12)))| (((d))>> (32-((12))))); (d) += (a); }; 
  {(c) += ((((d))& ((a)))| ((~(d))& ((b)))) + (in[ 2]) + (UINT4)(0x242070DBL); (c) = ((((c))<< ((17)))| (((c))>> (32-((17))))); (c) += (d); }; 
  {(b) += ((((c))& ((d)))| ((~(c))& ((a)))) + (in[ 3]) + (UINT4)(0xC1BDCEEEL); (b) = ((((b))<< ((22)))| (((b))>> (32-((22))))); (b) += (c); }; 
  {(a) += ((((b))& ((c)))| ((~(b))& ((d)))) + (in[ 4]) + (UINT4)(0xF57C0FAFL); (a) = ((((a))<< ((7)))| (((a))>> (32-((7))))); (a) += (b); }; 
  {(d) += ((((a))& ((b)))| ((~(a))& ((c)))) + (in[ 5]) + (UINT4)(0x4787C62AL); (d) = ((((d))<< ((12)))| (((d))>> (32-((12))))); (d) += (a); }; 
  {(c) += ((((d))& ((a)))| ((~(d))& ((b)))) + (in[ 6]) + (UINT4)(0xA8304613L); (c) = ((((c))<< ((17)))| (((c))>> (32-((17))))); (c) += (d); }; 
  {(b) += ((((c))& ((d)))| ((~(c))& ((a)))) + (in[ 7]) + (UINT4)(0xFD469501L); (b) = ((((b))<< ((22)))| (((b))>> (32-((22))))); (b) += (c); }; 
  {(a) += ((((b))& ((c)))| ((~(b))& ((d)))) + (in[ 8]) + (UINT4)(0x698098D8L); (a) = ((((a))<< ((7)))| (((a))>> (32-((7))))); (a) += (b); }; 
  {(d) += ((((a))& ((b)))| ((~(a))& ((c)))) + (in[ 9]) + (UINT4)(0x8B44F7AFL); (d) = ((((d))<< ((12)))| (((d))>> (32-((12))))); (d) += (a); }; 
  {(c) += ((((d))& ((a)))| ((~(d))& ((b)))) + (in[10]) + (UINT4)(0xFFFF5BB1L); (c) = ((((c))<< ((17)))| (((c))>> (32-((17))))); (c) += (d); }; 
  {(b) += ((((c))& ((d)))| ((~(c))& ((a)))) + (in[11]) + (UINT4)(0x895CD7BEL); (b) = ((((b))<< ((22)))| (((b))>> (32-((22))))); (b) += (c); }; 
  {(a) += ((((b))& ((c)))| ((~(b))& ((d)))) + (in[12]) + (UINT4)(0x6B901122L); (a) = ((((a))<< ((7)))| (((a))>> (32-((7))))); (a) += (b); }; 
  {(d) += ((((a))& ((b)))| ((~(a))& ((c)))) + (in[13]) + (UINT4)(0xFD987193L); (d) = ((((d))<< ((12)))| (((d))>> (32-((12))))); (d) += (a); }; 
  {(c) += ((((d))& ((a)))| ((~(d))& ((b)))) + (in[14]) + (UINT4)(0xA679438EL); (c) = ((((c))<< ((17)))| (((c))>> (32-((17))))); (c) += (d); }; 
  {(b) += ((((c))& ((d)))| ((~(c))& ((a)))) + (in[15]) + (UINT4)(0x49B40821L); (b) = ((((b))<< ((22)))| (((b))>> (32-((22))))); (b) += (c); }; 

  




  {(a) += ((((b))& ((d)))| (((c))& (~ (d)))) + (in[ 1]) + (UINT4)(0xF61E2562L); (a) = ((((a))<< ((5)))| (((a))>> (32-((5))))); (a) += (b); }; 
  {(d) += ((((a))& ((c)))| (((b))& (~ (c)))) + (in[ 6]) + (UINT4)(0xC040B340L); (d) = ((((d))<< ((9)))| (((d))>> (32-((9))))); (d) += (a); }; 
  {(c) += ((((d))& ((b)))| (((a))& (~ (b)))) + (in[11]) + (UINT4)(0x265E5A51L); (c) = ((((c))<< ((14)))| (((c))>> (32-((14))))); (c) += (d); }; 
  {(b) += ((((c))& ((a)))| (((d))& (~ (a)))) + (in[ 0]) + (UINT4)(0xE9B6C7AAL); (b) = ((((b))<< ((20)))| (((b))>> (32-((20))))); (b) += (c); }; 
  {(a) += ((((b))& ((d)))| (((c))& (~ (d)))) + (in[ 5]) + (UINT4)(0xD62F105DL); (a) = ((((a))<< ((5)))| (((a))>> (32-((5))))); (a) += (b); }; 
  {(d) += ((((a))& ((c)))| (((b))& (~ (c)))) + (in[10]) + (UINT4)(0x02441453L); (d) = ((((d))<< ((9)))| (((d))>> (32-((9))))); (d) += (a); }; 
  {(c) += ((((d))& ((b)))| (((a))& (~ (b)))) + (in[15]) + (UINT4)(0xD8A1E681L); (c) = ((((c))<< ((14)))| (((c))>> (32-((14))))); (c) += (d); }; 
  {(b) += ((((c))& ((a)))| (((d))& (~ (a)))) + (in[ 4]) + (UINT4)(0xE7D3FBC8L); (b) = ((((b))<< ((20)))| (((b))>> (32-((20))))); (b) += (c); }; 
  {(a) += ((((b))& ((d)))| (((c))& (~ (d)))) + (in[ 9]) + (UINT4)(0x21E1CDE6L); (a) = ((((a))<< ((5)))| (((a))>> (32-((5))))); (a) += (b); }; 
  {(d) += ((((a))& ((c)))| (((b))& (~ (c)))) + (in[14]) + (UINT4)(0xC33707D6L); (d) = ((((d))<< ((9)))| (((d))>> (32-((9))))); (d) += (a); }; 
  {(c) += ((((d))& ((b)))| (((a))& (~ (b)))) + (in[ 3]) + (UINT4)(0xF4D50D87L); (c) = ((((c))<< ((14)))| (((c))>> (32-((14))))); (c) += (d); }; 
  {(b) += ((((c))& ((a)))| (((d))& (~ (a)))) + (in[ 8]) + (UINT4)(0x455A14EDL); (b) = ((((b))<< ((20)))| (((b))>> (32-((20))))); (b) += (c); }; 
  {(a) += ((((b))& ((d)))| (((c))& (~ (d)))) + (in[13]) + (UINT4)(0xA9E3E905L); (a) = ((((a))<< ((5)))| (((a))>> (32-((5))))); (a) += (b); }; 
  {(d) += ((((a))& ((c)))| (((b))& (~ (c)))) + (in[ 2]) + (UINT4)(0xFCEFA3F8L); (d) = ((((d))<< ((9)))| (((d))>> (32-((9))))); (d) += (a); }; 
  {(c) += ((((d))& ((b)))| (((a))& (~ (b)))) + (in[ 7]) + (UINT4)(0x676F02D9L); (c) = ((((c))<< ((14)))| (((c))>> (32-((14))))); (c) += (d); }; 
  {(b) += ((((c))& ((a)))| (((d))& (~ (a)))) + (in[12]) + (UINT4)(0x8D2A4C8AL); (b) = ((((b))<< ((20)))| (((b))>> (32-((20))))); (b) += (c); }; 

  




  {(a) += (((b))^ ((c))^ ((d))) + (in[ 5]) + (UINT4)(0xFFFA3942L); (a) = ((((a))<< ((4)))| (((a))>> (32-((4))))); (a) += (b); }; 
  {(d) += (((a))^ ((b))^ ((c))) + (in[ 8]) + (UINT4)(0x8771F681L); (d) = ((((d))<< ((11)))| (((d))>> (32-((11))))); (d) += (a); }; 
  {(c) += (((d))^ ((a))^ ((b))) + (in[11]) + (UINT4)(0x6D9D6122L); (c) = ((((c))<< ((16)))| (((c))>> (32-((16))))); (c) += (d); }; 
  {(b) += (((c))^ ((d))^ ((a))) + (in[14]) + (UINT4)(0xFDE5380CL); (b) = ((((b))<< ((23)))| (((b))>> (32-((23))))); (b) += (c); }; 
  {(a) += (((b))^ ((c))^ ((d))) + (in[ 1]) + (UINT4)(0xA4BEEA44L); (a) = ((((a))<< ((4)))| (((a))>> (32-((4))))); (a) += (b); }; 
  {(d) += (((a))^ ((b))^ ((c))) + (in[ 4]) + (UINT4)(0x4BDECFA9L); (d) = ((((d))<< ((11)))| (((d))>> (32-((11))))); (d) += (a); }; 
  {(c) += (((d))^ ((a))^ ((b))) + (in[ 7]) + (UINT4)(0xF6BB4B60L); (c) = ((((c))<< ((16)))| (((c))>> (32-((16))))); (c) += (d); }; 
  {(b) += (((c))^ ((d))^ ((a))) + (in[10]) + (UINT4)(0xBEBFBC70L); (b) = ((((b))<< ((23)))| (((b))>> (32-((23))))); (b) += (c); }; 
  {(a) += (((b))^ ((c))^ ((d))) + (in[13]) + (UINT4)(0x289B7EC6L); (a) = ((((a))<< ((4)))| (((a))>> (32-((4))))); (a) += (b); }; 
  {(d) += (((a))^ ((b))^ ((c))) + (in[ 0]) + (UINT4)(0xEAA127FAL); (d) = ((((d))<< ((11)))| (((d))>> (32-((11))))); (d) += (a); }; 
  {(c) += (((d))^ ((a))^ ((b))) + (in[ 3]) + (UINT4)(0xD4EF3085L); (c) = ((((c))<< ((16)))| (((c))>> (32-((16))))); (c) += (d); }; 
  {(b) += (((c))^ ((d))^ ((a))) + (in[ 6]) + (UINT4)(0x04881D05L); (b) = ((((b))<< ((23)))| (((b))>> (32-((23))))); (b) += (c); }; 
  {(a) += (((b))^ ((c))^ ((d))) + (in[ 9]) + (UINT4)(0xD9D4D039L); (a) = ((((a))<< ((4)))| (((a))>> (32-((4))))); (a) += (b); }; 
  {(d) += (((a))^ ((b))^ ((c))) + (in[12]) + (UINT4)(0xE6DB99E5L); (d) = ((((d))<< ((11)))| (((d))>> (32-((11))))); (d) += (a); }; 
  {(c) += (((d))^ ((a))^ ((b))) + (in[15]) + (UINT4)(0x1FA27CF8L); (c) = ((((c))<< ((16)))| (((c))>> (32-((16))))); (c) += (d); }; 
  {(b) += (((c))^ ((d))^ ((a))) + (in[ 2]) + (UINT4)(0xC4AC5665L); (b) = ((((b))<< ((23)))| (((b))>> (32-((23))))); (b) += (c); }; 

  




  {(a) += (((c))^ (((b))| (~ (d)))) + (in[ 0]) + (UINT4)(0xF4292244L); (a) = ((((a))<< ((6)))| (((a))>> (32-((6))))); (a) += (b); }; 
  {(d) += (((b))^ (((a))| (~ (c)))) + (in[ 7]) + (UINT4)(0x432AFF97L); (d) = ((((d))<< ((10)))| (((d))>> (32-((10))))); (d) += (a); }; 
  {(c) += (((a))^ (((d))| (~ (b)))) + (in[14]) + (UINT4)(0xAB9423A7L); (c) = ((((c))<< ((15)))| (((c))>> (32-((15))))); (c) += (d); }; 
  {(b) += (((d))^ (((c))| (~ (a)))) + (in[ 5]) + (UINT4)(0xFC93A039L); (b) = ((((b))<< ((21)))| (((b))>> (32-((21))))); (b) += (c); }; 
  {(a) += (((c))^ (((b))| (~ (d)))) + (in[12]) + (UINT4)(0x655B59C3L); (a) = ((((a))<< ((6)))| (((a))>> (32-((6))))); (a) += (b); }; 
  {(d) += (((b))^ (((a))| (~ (c)))) + (in[ 3]) + (UINT4)(0x8F0CCC92L); (d) = ((((d))<< ((10)))| (((d))>> (32-((10))))); (d) += (a); }; 
  {(c) += (((a))^ (((d))| (~ (b)))) + (in[10]) + (UINT4)(0xFFEFF47DL); (c) = ((((c))<< ((15)))| (((c))>> (32-((15))))); (c) += (d); }; 
  {(b) += (((d))^ (((c))| (~ (a)))) + (in[ 1]) + (UINT4)(0x85845DD1L); (b) = ((((b))<< ((21)))| (((b))>> (32-((21))))); (b) += (c); }; 
  {(a) += (((c))^ (((b))| (~ (d)))) + (in[ 8]) + (UINT4)(0x6FA87E4FL); (a) = ((((a))<< ((6)))| (((a))>> (32-((6))))); (a) += (b); }; 
  {(d) += (((b))^ (((a))| (~ (c)))) + (in[15]) + (UINT4)(0xFE2CE6E0L); (d) = ((((d))<< ((10)))| (((d))>> (32-((10))))); (d) += (a); }; 
  {(c) += (((a))^ (((d))| (~ (b)))) + (in[ 6]) + (UINT4)(0xA3014314L); (c) = ((((c))<< ((15)))| (((c))>> (32-((15))))); (c) += (d); }; 
  {(b) += (((d))^ (((c))| (~ (a)))) + (in[13]) + (UINT4)(0x4E0811A1L); (b) = ((((b))<< ((21)))| (((b))>> (32-((21))))); (b) += (c); }; 
  {(a) += (((c))^ (((b))| (~ (d)))) + (in[ 4]) + (UINT4)(0xF7537E82L); (a) = ((((a))<< ((6)))| (((a))>> (32-((6))))); (a) += (b); }; 
  {(d) += (((b))^ (((a))| (~ (c)))) + (in[11]) + (UINT4)(0xBD3AF235L); (d) = ((((d))<< ((10)))| (((d))>> (32-((10))))); (d) += (a); }; 
  {(c) += (((a))^ (((d))| (~ (b)))) + (in[ 2]) + (UINT4)(0x2AD7D2BBL); (c) = ((((c))<< ((15)))| (((c))>> (32-((15))))); (c) += (d); }; 
  {(b) += (((d))^ (((c))| (~ (a)))) + (in[ 9]) + (UINT4)(0xEB86D391L); (b) = ((((b))<< ((21)))| (((b))>> (32-((21))))); (b) += (c); }; 

  buf[0] += a;
  buf[1] += b;
  buf[2] += c;
  buf[3] += d;
}

